var kanjilish_profile = null;

// Clones (=creates exact copy) of any object:
function kanjilish_clone(object)
{
    if (typeof(object) != "object") return object;

    var newObject = object.constructor();

    for (objectItem in object)
        newObject[objectItem] = kanjilish_clone(object[objectItem]);

	return newObject;
}

function kanjilish_profile_loadData()
{
	kanjilish_profile = window.arguments[0];

	var kanjilish_profile_returnObj = kanjilish_clone(kanjilish_profile[1]);
	kanjilish_profile_returnObj.sort();

	var list = document.getElementById("kanjilish_profiles");
	var len = kanjilish_profile_returnObj.length;

	for(var i = 0; i < len; i++)
	{
		var obj = kanjilish_profile_returnObj[i];
		addProfile(list, i, obj[0], obj[1].join(";"));
	}
}

function kanjilish_profile_unloadData()
{
	var name = kanjilish_profile[0];

	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
					   .getService(Components.interfaces.nsIWindowMediator);

	// reference to the main browser window:
	var browserWindow = wm.getMostRecentWindow("navigator:browser");
	var profiles = browserWindow.kanjilish.profiles;

	// Find the profile:
	for(var i = 0; i < profiles.length; i++)
	{
		if(profiles[i][0] == name)
		{
			kanjilish_profile[1] = [];
			profiles[i][1] = [];

			var list = document.getElementById("kanjilish_profiles");
			var len = list.itemCount;

			for(var j = 0; j < len; j++)
			{
				var item = list.getItemAtIndex(j);

				if(item)
				{
					var l1 = profiles[i][1].length;
					var l2 = kanjilish_profile[1].length;

					var key = item.firstChild.getAttribute("label");
					var knj = item.childNodes[1].getAttribute("label");

					profiles[i][1][l1] = [key, knj.split(";")];
					kanjilish_profile[1][l2] = [key, knj.split(";")];
				}
			}

			browserWindow.kanjilish.saveProfile(name);
			break;
		}
	}
}

function addProfile(list, count, key, kanjilish)
{
	var item = document.createElement('listitem');
	var cell1 = document.createElement('listcell');
	var cell2 = document.createElement('listcell');

	item.setAttribute('id', "kanjilish_item_" + count);

	cell1.setAttribute('id', "kanjilish_cell_1_" + count);
	cell2.setAttribute('id', "kanjilish_cell_2_" + count);

	cell1.setAttribute('label', key);
	cell2.setAttribute('label', kanjilish);

	item.appendChild(cell1);
	item.appendChild(cell2);
	list.appendChild(item);

	return item;
}

// Context menu commands:

function kanjilish_profiles_check(event)
{
	var id = event.explicitOriginalTarget.id;

	if((id.indexOf("kanjilish_item_") != -1) || (id.indexOf("kanjilish_cell_") != -1))
	{
		document.getElementById("kanjilish_profiles_menu_item2").setAttribute("disabled", false);
		document.getElementById("kanjilish_profiles_menu_item3").setAttribute("disabled", false);
	}
	else
	{
		document.getElementById("kanjilish_profiles_menu_item2").setAttribute("disabled", true);
		document.getElementById("kanjilish_profiles_menu_item3").setAttribute("disabled", true);		
	}
}

function kanjilish_profiles_menu_add(event)
{
	var returnObj = {key: "", kanjilish: ""};
	window.openDialog('chrome://kanjilish/content/entry.xul', 'KanjilishNewEntry', 'centerscreen=yes,chrome=yes,modal=yes', returnObj);

	if(returnObj.key.length && returnObj.kanjilish.length)
	{
		var list = document.getElementById("kanjilish_profiles");
		var item = addProfile(list, list.childNodes.length - 1, returnObj.key, returnObj.kanjilish);

		list.ensureElementIsVisible(item);
	}
}

function kanjilish_profiles_menu_edit(event)
{
	var list = document.getElementById("kanjilish_profiles");
	var profile_index = list.selectedIndex;
	var item = list.getItemAtIndex(profile_index);

	var returnObj = {key: item.childNodes[0].getAttribute("label"), kanjilish: item.childNodes[1].getAttribute("label")};
	window.openDialog('chrome://kanjilish/content/entry.xul', 'KanjilishNewEntry', 'centerscreen=yes,chrome=yes,modal=yes', returnObj);

	if(returnObj.key.length && returnObj.kanjilish.length)
	{
		var item = list.getItemAtIndex(profile_index);

		item.childNodes[0].setAttribute("label", returnObj.key);
		item.childNodes[1].setAttribute("label", returnObj.kanjilish);
	}	
}

function kanjilish_profiles_menu_delete(event)
{
	var list = document.getElementById('kanjilish_profiles');
	if(list.childNodes.length <= 2) return;

	var profile_index = list.selectedIndex;
	var next = (profile_index == -1) ? 0 : profile_index;

	list.removeChild(list.childNodes[profile_index + 2]);
	list.selectItem(list.childNodes[next + 2]);
}